::cisco::eem::event_register_timer cron name crontimer2 cron_entry $_cron_entry maxrun 240

#
# errorInfo gets set by namespace if any of the auto_path directories do not
# contain a valid tclIndex file.  It is not an error just left over stuff.
# So we set the errorInfo value to null so that we don't have left
# over errors in it.
#
set errorInfo ""

namespace import ::cisco::eem::*
namespace import ::cisco::lib::*

#
# errorInf gets set by namespace if any of the auto_path directories do not
# contain a valid tclIndex file.  It is not an error just left over stuff.
# So we set the errorInfo value to null so that we don't have left
# over errors in it.
#
set errorInfo ""
#Notify users that we're collecting
set output_msg "Collecting commands"
action_syslog priority info msg $output_msg
#query the event info
array set arr_einfo [event_reqinfo]

if {$_cerrno != 0} {
set result [format "component=%s; subsys err=%s; posix err=%s;\n%s" \
$_cerr_sub_num $_cerr_sub_err $_cerr_posix_err $_cerr_str]
error $result
}

#Extract the message from the event info and append it to the email body

##show_cmd will have the list of error disabled interfaces
set show_cmd "show error-disable | i link-oam-session-down"

#open a cli connection
if [catch {cli_open} result] {
error $result $errorInfo
} else {
array set cli1 $result
}

##Get the error disabled interfaces and save it in result
if [catch {cli_exec $cli1(fd) $show_cmd} result] {
error $result $errorInfo
}

foreach line_result [split $result "\n"] {
if {$line_result != ""} {
##Get the error disabled interfaces
action_syslog priority info msg "line_result $line_result"

set intf_err_dis ""
regexp {.*(Gi.*)link-oam-session-down .*} $line_result output intf_err_dis
if {$intf_err_dis != ""} {
##show_cmd1 will get the Rx Power of error disabled interface

set show_cmd1 "show controller $intf_err_dis phy | i Receive Power:"
set show_cmd2 "show controller $intf_err_dis phy | i Rx Power:"

##Get the Rx Power threshold of error dialled interface
if [catch {cli_exec $cli1(fd) $show_cmd1} result1] {
error $result $errorInfo
}
#####Get the Rx Threshhold
regexp {.*Receive Power:.*(-.*)dBm.*} $result1 output rx_power_thresh
action_syslog priority info msg "****$rx_power_thresh****"

##Get the Rx Power of error dialled interface
if [catch {cli_exec $cli1(fd) $show_cmd2} result2] {
error $result $errorInfo
}
##Extract the Rx power
regexp {.*Rx Power:.*(-.*)dBm.*} $result2 output rx_power
action_syslog priority info msg "****$rx_power*****"

if {$rx_power < $rx_power_thresh} {
action_syslog priority info msg "===Low Rx Power, not flap the interface===="
} else {
action_syslog priority info msg "=====Rx Power Ok...Flap the interface====="
##Shut the interface
if [catch {cli_exec $cli1(fd) "conf t"} result] {
error $result $errorInfo
}
if [catch {cli_exec $cli1(fd) "int $intf_err_dis"} result] {
error $result $errorInfo
}
if [catch {cli_exec $cli1(fd) "shutdown"} result] {
error $result $errorInfo
}
if [catch {cli_exec $cli1(fd) "commit"} result] {
error $result $errorInfo
}

######################################Unshut the interface

if [catch {cli_exec $cli1(fd) "int $intf_err_dis"} result] {
error $result $errorInfo
}
if [catch {cli_exec $cli1(fd) "no shutdown"} result] {
error $result $errorInfo
}
if [catch {cli_exec $cli1(fd) "commit"} result] {
error $result $errorInfo
}
######################################
}
}
}
}
#close the cli connection
if [catch {cli_close $cli1(fd) $cli1(tty_id)} result] {
error $result $errorInfo
}


